#ifndef ANNOTATEDFAMILY_H
#define ANNOTATEDFAMILY_H

#include "EM.h"
#include "Family.h"
#include "FounderHaplotypes.h"
#include "HaplotypeMatrix.h"
#include "InheritanceDistribution.h"
#include "PenetranceMatrix.h"
#include "Vector.h"

typedef struct AnnotatedFamilyStruct *AnnotatedFamily;

AnnotatedFamily AnnotatedFamily_Create(Family, Vector test_marker_set);
AnnotatedFamily AnnotatedFamily_CreateWithInheritanceDistro(Family, Vector test_marker_set, InheritanceDistribution distro);
void AnnotatedFamily_Destroy(AnnotatedFamily);
Family AnnotatedFamily_GetFamily(AnnotatedFamily);
PenetranceMatrix AnnotatedFamily_GetPenetranceMatrix(AnnotatedFamily);
HaplotypeMatrix AnnotatedFamily_GetHaplotypeMatrix(AnnotatedFamily);
HaplotypeMatrix AnnotatedFamily_GetHaplotypeMatrixWithoutDiseaseLocus(AnnotatedFamily);
void AnnotatedFamily_SetInheritanceDistribution(AnnotatedFamily, InheritanceDistribution);
InheritanceDistribution AnnotatedFamily_GetInheritanceDistribution(AnnotatedFamily);
Vector AnnotatedFamily_GetPQTerms(AnnotatedFamily);
int AnnotatedFamily_GetSingleton(AnnotatedFamily annotated_family);
FounderHaplotypes AnnotatedFamily_GetFounderHaplotypes(AnnotatedFamily annotated_family);
int AnnotatedFamily_GetNumberOfInheritanceVectors(AnnotatedFamily annotated_family);

#endif
