#ifndef COMMAND_READER_H
#define COMMAND_READER_H
#include <stdint.h>      // int16_t, INT16_MAX

typedef struct CommandReaderStruct *CommandReader;

CommandReader CommandReader_Create(const char *command_file);
void CommandReader_Write(CommandReader, const char *command_file, int16_t seed);
int CommandReader_CopyUserFile(CommandReader, const char *command_name, const char *directory);
const char *CommandReader_GetPedFile(CommandReader);
const char *CommandReader_GetMarkerFile(CommandReader);
const char *CommandReader_GetUserAssociationRegionsFile(CommandReader);
const char *CommandReader_GetUserLinkageMarkersFile(CommandReader);
const char *CommandReader_GetLogFile(CommandReader);
const char *CommandReader_GetOutputFile(CommandReader);
const char *CommandReader_GetUserAssociationModelsFile(CommandReader);

#endif
