#ifndef EM_H
#define EM_H

#include "DoubleVector.h"
#include "Family.h"
#include "Marker.h"
#include "Vector.h"

DoubleVector EM_Haplotype_H0(Vector annotated_families, Vector test_markers);
double *EM_Allele_Frequencies(Vector annotated_families, int number_of_families, int total_founders, Marker marker, int which_marker);
double EM_Haplotype_GetLikelihood(Vector annotated_families, double *em_freqs, int number_of_families, int number_of_haplotypes);
double EM_Allele_Frequencies_GetLikelihood(Vector annotated_families, double *em_freqs, int number_of_families, int number_of_haplotypes, int which_marker);
void EM_ComputeMarkerFrequencies(Vector markers, Vector families);
double EM_ComputeLinkageMarkerLikelihood(Vector allele_exponents, Vector families, double *em_freqs_old, int number_of_families, int number_of_haplotypes);
Vector EM_ComputeAlleleExponents(Family family, Marker marker);
double *EM_ComputeMarkerAlleleFrequencies(Vector allele_exponents, Vector families, int number_of_families, int total_founders, Marker marker);

#endif
