#ifndef HAPLOTYPETERM_H
#define HAPLOTYPETERM_H

#include "DoubleVector.h"
#include "PhasedGenotypes.h"

#define MAX_NUMBER_OF_TEST_MARKERS 3

typedef struct HaplotypeTermStruct *HaplotypeTerm;

HaplotypeTerm HaplotypeTerm_Create(int number_of_haplotypes);
void HaplotypeTerm_Add(HaplotypeTerm, int *exponents);
double HaplotypeTerm_Evaluate(HaplotypeTerm, DoubleVector frequencies, double **cache);
int *HaplotypeTerm_ComputeExponents(HaplotypeTerm, int number_of_founders, PhasedGenotypes disease_genotypes, PhasedGenotypes *test_marker_genotypes, int number_of_test_markers);
DoubleVector HaplotypeTerm_GetWildtypeFrequencies(DoubleVector haplotype_frequencies);
int HaplotypeTerm_GetNumberOfAlleles(int number_of_haplotypes);
void HaplotypeTerm_Destroy(HaplotypeTerm);
double HaplotypeTerm_GetMutantFrequency(DoubleVector haplotype_frequencies);
int HaplotypeTerm_IsEmpty(HaplotypeTerm term);
void HaplotypeTerm_Show(HaplotypeTerm term);
HaplotypeTerm HaplotypeTerm_RemoveDiseaseLocus(HaplotypeTerm term);

#endif
