#ifndef HAPLOTYPES_H
#define HAPLOTYPES_H

#include "PhasedGenotypes.h"
#include "Genotype.h"
#include "Vector.h"
#include "DoubleVector.h"

#define MAX_NUMBER_OF_TEST_MARKERS 3
#define MAX_NUMBER_OF_POSSIBLE_HAPLOTYPES (1 << (MAX_NUMBER_OF_TEST_MARKERS + 1))

typedef char *Haplotypes;

#define Haplotypes_Get(haplotypes, which) ((haplotypes)[(which)])
Haplotypes Haplotypes_Create(void);
extern void (*Haplotypes_GetForFounders)(Haplotypes, int number_of_founders, PhasedGenotypes, PhasedGenotypes *phased_genotypes_of_test_markers, int number_of_test_markers);
int Haplotypes_GetIndexOfLeftHaplotype(Genotype disease_genotype, Genotype *genotype_of_test_markers, int number_of_test_markers);
int Haplotypes_GetIndexOfRightHaplotype(Genotype disease_genotype, Genotype *genotype_of_test_markers, int number_of_test_markers);
void Haplotypes_Destroy(Haplotypes);
DoubleVector Haplotypes_GetExpectedFrequencies(Vector markers);
double Haplotypes_GetExpectedDiseaseAlleleFrequency(DoubleVector haplotype_frequencies);
int Haplotypes_ContainsDiseaseAllele(int haplotype);

#endif
