#ifndef MARKER_H
#define MARKER_H

#include "Vector.h"

typedef struct MarkerStruct *Marker;

Marker Marker_Create(const char *marker_name, int marker_index);
void Marker_Destroy(Marker);
const char *Marker_GetName(Marker);
int Marker_GetIndex(Marker);
void Marker_SetNumberOfAlleles(Marker, int number_of_alleles);
void Marker_SetAlleleFrequencies(Marker, int number_of_alleles, double *allele_frequencies);
int Marker_GetNumberOfAlleles(Marker);
double Marker_GetAlleleFrequency(Marker, int allele);
Vector Marker_GetAlleleFrequencies(Marker);
void Marker_Show(Marker);
double Marker_GetSumOfAlleleFrequencies(Marker marker);
double *Marker_GetEMAlleleFrequencies(Marker marker);
void Marker_SetEMAlleleFrequencies(Marker marker, double *freqs);
int Marker_SetAlleleCodes(Marker marker, int *allele_codes, int number_of_allele_codes);
int Marker_GetNumberOfAlleleCodes(Marker marker);
int Marker_ConvertTo01(Marker marker, int allele);
int Marker_ConvertFrom01(Marker marker, int allele);
int Marker_GetAlleleCodeByIndex(Marker marker, int allele_index);

#endif
