#ifndef PEDIGREEFILE_H
#define PEDIGREEFILE_H

typedef struct PedigreeFileStruct *PedigreeFile;

#include "LinkageMarkerFile.h"
#include "PedigreeFileRecord.h"
#include "UserLinkageMarkerFile.h"

PedigreeFile PedigreeFile_Create(const char *filename);
void PedigreeFile_Destroy(PedigreeFile);
int PedigreeFile_GetNumberOfFamilies(PedigreeFile);
PedigreeFileRecord PedigreeFile_GetRecord(PedigreeFile, const char *family_name, const char *person_name);
const char *PedigreeFile_GetFamilyName(PedigreeFile, int family_position_in_ped_file);
int PedigreeFile_GetNumberOfRecords(PedigreeFile);
PedigreeFileRecord PedigreeFile_GetRecordByIndex(PedigreeFile, int i);
const int *PedigreeFile_GetConvertedAlleles(PedigreeFile, const char *family_name, const char *person_name, LinkageMarkerFile, UserLinkageMarkerFile);

#endif
