#ifndef PEDIGREEFILERECORD_H
#define PEDIGREEFILERECORD_H

typedef struct PedigreeFileRecordStruct *PedigreeFileRecord;

PedigreeFileRecord PedigreeFileRecord_Create(char *line);
const char *PedigreeFileRecord_GetFamilyId(PedigreeFileRecord record);
const char *PedigreeFileRecord_GetIndividualId(PedigreeFileRecord record);
const char *PedigreeFileRecord_GetFatherId(PedigreeFileRecord record);
const char *PedigreeFileRecord_GetMotherId(PedigreeFileRecord record);
const char *PedigreeFileRecord_GetSex(PedigreeFileRecord record);
const char *PedigreeFileRecord_GetAffectionStatus(PedigreeFileRecord record);
const char *PedigreeFileRecord_GetAllele1(PedigreeFileRecord record, int marker);
const char *PedigreeFileRecord_GetAllele2(PedigreeFileRecord record, int marker);
const char *PedigreeFileRecord_GetGenotypes(PedigreeFileRecord record);
void PedigreeFileRecord_GetAlleles(PedigreeFileRecord record, char ***a1, char ***a2);
void PedigreeFileRecord_Destroy(PedigreeFileRecord record);
int PedigreeFileRecord_GetNumberOfMarkers(PedigreeFileRecord record);

#endif
