#ifndef PEDIGREEFILESIMULATOR_H
#define PEDIGREEFILESIMULATOR_H

#include <inttypes.h>  // int16_t

#include "DoubleVector.h"
#include "IntSet.h"
#include "LinkageMarkerFile.h"
#include "ModelParamsFile.h"
#include "PedigreeFile.h"
#include "UserLinkageMarkerFile.h"
#include "Vector.h"

typedef struct PedigreeFileSimulatorStruct *PedigreeFileSimulator;

PedigreeFileSimulator PedigreeFileSimulator_Create(Vector families, PedigreeFile, LinkageMarkerFile, UserLinkageMarkerFile, Vector test_markers, ModelParamsFile, DoubleVector hapfreqs);
void PedigreeFileSimulator_Simulate(PedigreeFileSimulator, const char *simulated_pedfile);
IntSet PedigreeFileSimulator_GetMarkerIndexesToKeep(PedigreeFileSimulator);
IntSet PedigreeFileSimulator_GetTestMarkerIndexes(PedigreeFileSimulator);

#endif
