#ifndef PENETRANCES_H
#define PENETRANCES_H

#include "Person.h"
#include "Vector.h"
#include "PhasedGenotypes.h"

typedef enum {
    F0,       // 0 sick without any disease allele
    F1_PAT,   // 1 sick with father's disease allele
    F1_MAT,   // 2 sick with mother's disease allele
    F2,       // 3 sick with both disease alleles
    UF0,      // 4 healthy without any disease allele
    UF1_PAT,  // 5 healthy with father's disease allele
    UF1_MAT,  // 6 healthy with mother's disease allele
    UF2,      // 7 healthy with both disease alleles
    FF1_AVG,  // 8 founder sick with disease allele: (F1_PAT + F1_MAT) / 2
    UFF1_AVG  // 9 founder healthy with disease allele: (UF1_PAT + UF1_MAT) / 2
} PenetranceIndex;

#define NUMBER_OF_PENETRANCES 10

typedef unsigned char *Penetrances;

Penetrances Penetrances_Create(void);
void Penetrances_Destroy(Penetrances);
PenetranceIndex Penetrances_GetForFounder(Person, Genotype);
PenetranceIndex Penetrances_GetForNonfounder(Person, Genotype);
void Penetrances_GetForNonfounders(Penetrances, Vector, PhasedGenotypes);
void Penetrances_GetForFounders(Penetrances, Vector, PhasedGenotypes);

#endif
