#ifndef HASHTABLETEMPLATEINTERNALS_H
#define HASHTABLETEMPLATEINTERNALS_H

#define C(A,B) A ## B

#define HashTableTemplate(T) \
typedef int (*C(T,compare_func))(const void *, const void *); \
typedef struct C(T,HashTableStruct) *C(T,HashTable); \
C(T,HashTable) C(T,HashTable_Create)(int size); \
void C(T,HashTable_Destroy)(C(T,HashTable)); \
void C(T,HashTable_Put)(C(T,HashTable), T key, void *value); \
int C(T,HashTable_Get)(C(T,HashTable), T key, void **value); \
int C(T,HashTable_GetSize)(C(T,HashTable)); \
int C(T,HashTable_GetLength)(C(T,HashTable)); \
T *C(T,HashTable_SortKeys)(C(T,HashTable), C(T,compare_func));

#endif
