#ifndef LIST_H
#define LIST_H

typedef struct ListStruct *List;
typedef int (*Predicate)(void *item, void *additional_arguments);

List List_Create(void);
void List_Destroy(List);
List List_AddItem(List, void *item);
List List_GetNext(List);
void *List_GetItem(List);
int List_GetSize(List);
int List_HasNext(List);
int List_IsEmpty(List);
List List_RemoveIf(Predicate, List, void *additional_arguments);

#endif
