#include "Memory.h"
#include "ModScore.h"

#include <math.h>

ModScore *ModScore_Create(void)
{
    ModScore *mod_score = Memory_Malloc(sizeof(ModScore));
    ModScore_Clear(mod_score);
    return mod_score;
}

void ModScore_Clear(ModScore *mod_score)
{
    mod_score->test_markers = NULL;
    mod_score->position = -1;
    mod_score->mod_score = -HUGE_VAL;
    mod_score->disease_allele_frequency = -1;
    mod_score->penetrances = NULL;
    mod_score->hapfreqs = NULL;
    mod_score->em_hapfreqs = NULL;
    mod_score->deltas = NULL;
}

void ModScore_Update(ModScore *dst, ModScore *src)
{
    dst->test_markers = Vector_Copy(src->test_markers);
    dst->position = src->position;
    dst->mod_score = src->mod_score;
    dst->disease_allele_frequency = src->disease_allele_frequency;
    dst->penetrances = DoubleVector_Copy(src->penetrances);
    dst->hapfreqs = DoubleVector_Copy(src->hapfreqs);
    dst->em_hapfreqs = DoubleVector_Copy(src->em_hapfreqs);
    if (src->deltas)
        dst->deltas = DoubleVector_Copy(src->deltas);
}
