#include "PQTerm.h"
#include "Memory.h"
#include <math.h>

struct PQTermStruct {
    int p;
    int q;
};

PQTerm PQTerm_Create(int disease_genotypes, int number_of_founders)
{
    PQTerm term = Memory_Malloc(sizeof(*term));
    term->p = 0;
    for (int i = 0; i < 2 * number_of_founders; i++)
        term->p += (disease_genotypes >> i) & 0x1;
    term->q = 2 * number_of_founders - term->p;
    return term;
}

int PQTerm_GetExponentOfP(PQTerm term)
{
    return term->p;
}

int PQTerm_GetExponentOfQ(PQTerm term)
{
    return term->q;
}

void PQTerm_Destroy(PQTerm term)
{
    Memory_Free(term);
}

double PQTerm_Evaluate(PQTerm term, double p)
{
    return pow(p, term->p) * pow(1-p, term->q);
}
