/* GENEHUNTER-MODSCORE - memory_realloc.h
   module to allocate memory for algebraic calculation
   written by Markus Brugger, Copyright (c) 2019 */

#ifndef memory_realloc_h
#define memory_realloc_h

#include <stdlib.h>
#include "../ansilib/iolib.h"
#include "../ansilib/strlib.h"

#define matrix_realloc(mat, i, n, cols, type) {\
	unsigned int size = 0; \
	int k; \
	mat = realloc(mat, n*sizeof(type*)); \
	if(NULL == mat){\
		sf(ps, "\nNot enough memory, please try using 'algebraic calculation mode off'.\n"); pr(); \
		exit(EXIT_FAILURE); \
	}\
	size += n*sizeof(type*); \
	for(k=i; k < n; k++){ \
		type *p; \
		array(p, cols, type); \
		if(NULL == p){\
			sf(ps, "\nNot enough memory, please try using 'algebraic calculation mode off'.\n"); pr(); \
			exit(EXIT_FAILURE); \
		}\
		mat[k]=p; \
	} \
		size += cols*n*sizeof(type); \
}
	     
#define array_realloc(array, n, type) {\
	unsigned int size = 0; \
	array = realloc(array, n*sizeof(type)); \
	if(NULL == array){\
		sf(ps, "\nNot enough memory, please try using 'algebraic calculation mode off'.\n"); pr(); \
		exit(EXIT_FAILURE); \
	}\
	size += n*sizeof(type); \
}

#define total_realloc(mat, i, n, cols, type) {\
	int k; \
	for(k=0; k < i; k++){ \
		type *p;\
		p = mat[k]; \
	        p = realloc(p, cols*sizeof(type)); \
		if(NULL == p){\
			sf(ps, "\nNot enough memory, please try using 'algebraic calculation mode off'.\n"); pr(); \
			exit(EXIT_FAILURE); \
		}\
		mat[k] = p; \
	}\
	matrix_realloc(mat, i, n, cols, type); \
}

#define par_score_realloc(mat, i, n, type) {\
	unsigned int size = 0; \
	int k; \
	mat = realloc(mat, n*sizeof(type*)); \
	if(NULL == mat){\
		sf(ps, "\nNot enough memory, please try using 'algebraic calculation mode off'.\n"); pr(); \
		exit(EXIT_FAILURE); \
	}\
	size += n*sizeof(type*); \
	for(k=i; k < n; k++){ \
		mat[k] = NULL; \
	}\
}

#endif
