#include "Matrix.h"
#include "Memory.h"
#include <stddef.h>

Matrix Matrix_Create(int number_of_rows, int number_of_columns)
{
    Matrix matrix;
    int i, j;

    matrix = (Matrix) Memory_Malloc(sizeof(*matrix));
    matrix->matrix = (void ***) Memory_Malloc(number_of_rows * sizeof(void **));
    for (i = 0; i < number_of_rows; i++) {
        matrix->matrix[i] = (void **) Memory_Malloc(number_of_columns * sizeof(void *));
        for (j = 0; j < number_of_columns; j++)
            matrix->matrix[i][j] = NULL;
    }
    matrix->rows = number_of_rows;
    matrix->columns = number_of_columns;

    return matrix;
}

void *Matrix_Get(Matrix matrix, int row, int column)
{
    return matrix->matrix[row][column];
}

void Matrix_Set(Matrix matrix, int row, int column, void *value)
{
    matrix->matrix[row][column] = value;
}

void Matrix_Destroy(Matrix matrix)
{
    int i;

    if (matrix == NULL)
        return;

    for (i = 0; i < matrix->rows; i++)
        Memory_Free(matrix->matrix[i]);
    Memory_Free(matrix->matrix);
    Memory_Free(matrix);
}

int Matrix_GetNumberOfRows(Matrix matrix)
{
    return matrix->rows;
}

int Matrix_GetNumberOfColumns(Matrix matrix)
{
    return matrix->columns;
}
