#include "Str.h"
#include "Memory.h"
#include <stdio.h>
#include <stdarg.h>
#include <string.h>

static int get_required_size_in_bytes(const char *format, va_list);

const char *String_FromFormat(const char *format, ...)
{
    va_list ap;
    int required_size;
    char *s;

    va_start(ap, format);
    required_size = get_required_size_in_bytes(format, ap);
    s = (char *) Memory_Malloc(required_size);
    vsnprintf(s, required_size, format, ap);
    va_end(ap);

    return s;
}

const char *String_FromFormat2(const char *format, va_list ap)
{
    int required_size = get_required_size_in_bytes(format, ap);
    char *s;

    s = (char *) Memory_Malloc(required_size);
    vsnprintf(s, required_size, format, ap);

    return s;
}

static int get_required_size_in_bytes(const char *format, va_list ap)
{
    va_list aq;
    int required_size;

    va_copy(aq, ap);
    required_size = vsnprintf(NULL, 0, format, aq);
    va_end(aq);

    return required_size + 1;  // +1 for terminating '\0'
}

int String_Equal(const char *s, const char *t)
{
    return strcmp(s, t) == 0;
}
